<?php
/*
	Template Name: 設定画面
*/

if(!defined('ABSPATH')) exit;

/* Welcart有効確認 */
include_once(ABSPATH . 'wp-admin/includes/plugin.php');
if (is_plugin_active('usc-e-shop/usc-e-shop.php')):

/* 設定情報 */
//取得
$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
//サポート機能
$ffwDataNameArr = array('couponDiscountsCode','couponDiscountsPrice','couponDiscountsUnit','shippingDiscountsA','shippingDiscountsB','conversionTag','changeLinkCartPrebutton','changeAfterLogin','changeAfterLogout','changeOrderEmail','removeOrderEmailMemberNo','pdfSignImage','removeOGP');
foreach ($ffwDataNameArr as $key => $val){
	if($_POST['submit_settings_data_1']){
		if(!empty($_REQUEST[$val])){
			if($val == 'conversionTag'){
				$friendlyFunctionsForWelcartData[$val] = htmlspecialchars($_REQUEST[$val], ENT_QUOTES, "UTF-8");
			}else{
				$friendlyFunctionsForWelcartData[$val] = sanitize_text_field($_REQUEST[$val]);
			}
		}else{
			unset($friendlyFunctionsForWelcartData[$val]);
		}
	}
	$$val = $friendlyFunctionsForWelcartData[$val]; //可変変数
}
//ユーザビリティ
$ffwDataNameArr = array('shippingDiscountsMessage','postagePrivilegeMessage','displayFurigana','displayFaxNum','quantityEntryNum','formErrorCheck','preventExpiration','onThanksgivingPage','extendSearch','cssInlineOutput');
foreach ($ffwDataNameArr as $key => $val){
	if($_POST['submit_settings_data_2']){
		if(!empty($_REQUEST[$val])){
			$friendlyFunctionsForWelcartData[$val] = sanitize_text_field($_REQUEST[$val]);
		}else{
			unset($friendlyFunctionsForWelcartData[$val]);
		}
	}
	$$val = $friendlyFunctionsForWelcartData[$val]; //可変変数
}

//DB更新
update_option('friendlyFunctionsForWelcartData',$friendlyFunctionsForWelcartData);

//設定保存時のメッセージ
if(isset($_POST['submit_settings'])){
	$saveMessage = '<div class="saveMessage updated"><p>'.sprintf(esc_html__('%s saved.', 'friendly-functions-for-welcart'), $_POST['submit_settings']).'</p></div>'; // ～を保存しました。
}
?>

<section class="ffwSettingsSection">
	<?php echo $saveMessage; ?>
	<h1 id="headTitlePluginName" class="wp-heading-inline">Friendly Functions for Welcart</h1>

	<input id="settingsTab1" type="radio" name="tab_settings" checked><label for="settingsTab1"><span class="tabLabel"><?php esc_html_e('Support Functions Settings', 'friendly-functions-for-welcart'); //サポート機能 ?></span></label>
	<input id="settingsTab2" type="radio" name="tab_settings"><label for="settingsTab2"><span class="tabLabel"><?php esc_html_e('Usability Settings', 'friendly-functions-for-welcart'); //ユーザビリティ ?></span></label>

	<div id="settings1" class="tab_content">
		<form class="settingsForm1" method="post" action="admin.php?page=ffw_function_settings">
			<div class="ffwGrayBackground">
				<table class="form-table">
					<tr valign="top">
						<th scope="row"><label for="couponDiscounts"><?php esc_html_e('Coupon Discount', 'friendly-functions-for-welcart'); //クーポン割引 ?></label></th>
						<td>
							<span class="flex flexStartWrap flexCenterColumn marginBottom8"><?php esc_html_e('Coupon Code:', 'friendly-functions-for-welcart'); //クーポンコード： ?><input name="couponDiscountsCode" type="text" value="<?php echo $couponDiscountsCode; ?>" class="regular-text ffwSmallTextInput"></span>
							<span class="flex flexStartWrap flexCenterColumn">
							<?php esc_html_e('Discount Amount:', 'friendly-functions-for-welcart'); //割引額： ?><input name="couponDiscountsPrice" type="number" value="<?php echo $couponDiscountsPrice; ?>" class="regular-text ffwSmallTextInput">
								<select name="couponDiscountsUnit">
									<option value="price"<?php if($couponDiscountsUnit == 'price' || empty($couponDiscountsUnit)){echo ' selected';} ?>><?php esc_html_e('$', 'friendly-functions-for-welcart'); //円 ?></option>
									<option value="percent"<?php if($couponDiscountsUnit == 'percent'){echo ' selected';} ?>><?php esc_html_e('%', 'friendly-functions-for-welcart'); //％ ?></option>
								</select>
							</span>
							<p class="description"><?php esc_html_e('The "Coupon Code" input field will be displayed on the "Shipping and Payment" page, and the set amount will be discounted from the purchase amount when the set coupon code is entered. Please note that this offer cannot be used in conjunction with the "Campaign".', 'friendly-functions-for-welcart'); //「発送・支払方法」ページに「クーポンコード」入力欄を表示し、設定したクーポンコードを入力した場合に購入額から設定した額を割り引きます。「キャンペーン」とは併用できないのでご注意ください。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="shippingDiscounts"><?php esc_html_e('Shipping Discount', 'friendly-functions-for-welcart'); //送料割引 ?></label></th>
						<td>
							<div class="shippingDiscountsAWrap"><?php echo sprintf(__('$%s over', 'friendly-functions-for-welcart'), '<input name="shippingDiscountsA" type="number" value="'.$shippingDiscountsA.'" class="regular-text ffwSmallTextInput">'); //円以上の購入で ?></div>
							<div class="shippingDiscountsBWrap"><?php echo sprintf(__('$%s discount', 'friendly-functions-for-welcart'), '<input name="shippingDiscountsB" type="number" value="'.$shippingDiscountsB.'" class="regular-text ffwSmallTextInput">'); //円割引 ?></div>
							<p class="description"><?php esc_html_e('If you have set up the "Free Shipping Terms" in Welcart, the discount will be applied to your order.', 'friendly-functions-for-welcart'); //指定の購入額以上で、送料から任意の額を割り引きます。Welcartの「送料無料条件」を設定している場合、合わせて適用されます。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="conversionTag"><?php esc_html_e('Conversion tag installation', 'friendly-functions-for-welcart'); //コンバージョンタグ設置 ?></label></th>
						<td>
							<textarea name="conversionTag" class="code"><?php echo stripslashes(htmlspecialchars_decode($conversionTag, ENT_QUOTES)); ?></textarea>
							<p class="description"><?php esc_html_e('Outputs the code set for the Thanksgiving page (purchase completion screen). Please use it to place a conversion tag.', 'friendly-functions-for-welcart'); //サンクスページ（購入完了画面）に設定したコードを出力します。コンバージョンタグの設置等にご利用ください。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="changeLinkCartPrebutton"><?php esc_html_e('Change "Continue Shopping" link', 'friendly-functions-for-welcart'); //「買い物を続ける」のリンク先変更 ?></label></th>
						<td>
							<input name="changeLinkCartPrebutton" type="url" value="<?php echo $changeLinkCartPrebutton; ?>" class="regular-text">
							<p class="description"><?php esc_html_e('You can specify the link to "Continue Shopping". If you want to change it, please enter the URL including "https://".', 'friendly-functions-for-welcart'); //「買い物を続ける」のリンク先を指定できます。変更する場合は「https://」を含めてURLをご入力ください。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="changeAfterLogin"><?php esc_html_e('Change transition page after login', 'friendly-functions-for-welcart'); //ログイン後の遷移ページ変更 ?></label></th>
						<td>
							<input name="changeAfterLogin" type="url" value="<?php echo $changeAfterLogin; ?>" class="regular-text">
							<p class="description"><?php esc_html_e('You can specify the page to go to after the user login. If you want to change it, please enter the URL including "https://".', 'friendly-functions-for-welcart'); //ユーザーがログインした後に移動するページを指定できます。変更する場合は「https://」を含めてURLをご入力ください。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="changeAfterLogout"><?php esc_html_e('Change transition page after logout', 'friendly-functions-for-welcart'); //ログアウト後の遷移ページ変更 ?></label></th>
						<td>
							<input name="changeAfterLogout" type="url" value="<?php echo $changeAfterLogout; ?>" class="regular-text">
							<p class="description"><?php esc_html_e('You can specify the page to go to after the user logout. If you want to change it, please enter the URL including "https://".', 'friendly-functions-for-welcart'); //ユーザーがログアウトした後に移動するページを指定できます。変更する場合は「https://」を含めてURLをご入力ください。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="changeOrderEmail"><?php esc_html_e('Change the sender of the order email to the purchaser\'s address', 'friendly-functions-for-welcart'); //受注メールの差出人を購入者のアドレスに変更 ?></label></th>
						<td>
							<select name="changeOrderEmail">
								<option value="yes"<?php if($changeOrderEmail == 'yes'){echo ' selected';} ?>><?php esc_html_e('Change', 'friendly-functions-for-welcart'); //変更する ?></option>
								<option value="no"<?php if($changeOrderEmail == 'no' || empty($changeOrderEmail)){echo ' selected';} ?>><?php esc_html_e('No change', 'friendly-functions-for-welcart'); //変更しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('Usually, you can change the sender of the administrator email address to the purchaser\'s email address to make the reply smoother.', 'friendly-functions-for-welcart'); //通常は管理者メールアドレスの差出人を、購入者のメールアドレスに変更することで返信がスムーズになります。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="removeOrderEmailMemberNo"><?php esc_html_e('Deletion of "Membership Number" from order email', 'friendly-functions-for-welcart'); //受注メールから「会員No」を削除 ?></label></th>
						<td>
							<select name="removeOrderEmailMemberNo">
								<option value="yes"<?php if($removeOrderEmailMemberNo == 'yes'){echo ' selected';} ?>><?php esc_html_e('Remove', 'friendly-functions-for-welcart'); //削除する ?></option>
								<option value="no"<?php if($removeOrderEmailMemberNo == 'no' || empty($removeOrderEmailMemberNo)){echo ' selected';} ?>><?php esc_html_e('No remove', 'friendly-functions-for-welcart'); //削除しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('Delete the "Membership Number" description from the order email automatically sent when an order is placed.', 'friendly-functions-for-welcart'); //注文時に自動送信される受注メールから「会員No」の記述を削除します。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="pdfSignImage"><?php esc_html_e('Display images on estimates, delivery slips, receipts, and invoices', 'friendly-functions-for-welcart'); //見積書・納品書・領収書・請求書に画像を表示 ?></label></th>
						<td>
							<?php friendly_functions_for_welcart_generate_upload_image_tag('pdfSignImage', $pdfSignImage); ?>
							<p class="description"><?php esc_html_e('Display any image on a quotation, delivery note, receipt, or invoice. You can use this feature if you want to put your seal, logo, etc. on it.', 'friendly-functions-for-welcart'); //見積書・納品書・領収書・請求書に任意の画像を表示します。印鑑やロゴ等を載せてい場合にご利用いただけます。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="removeOGP"><?php esc_html_e('Remove OGP property output by Welcart', 'friendly-functions-for-welcart'); //Welcartが出力するOGPプロパティ削除 ?></label></th>
						<td>
							<select name="removeOGP">
								<option value="yes"<?php if($removeOGP == 'yes'){echo ' selected';} ?>><?php esc_html_e('Remove', 'friendly-functions-for-welcart'); //削除する ?></option>
								<option value="no"<?php if($removeOGP == 'no' || empty($removeOGP)){echo ' selected';} ?>><?php esc_html_e('No remove', 'friendly-functions-for-welcart'); //削除しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('Disables the OGP property output by Welcart. Please use this option when OGP is duplicated by themes or other plugins.', 'friendly-functions-for-welcart'); //Welcartが出力するOGPプロパティを無効化します。テーマや他のプラグインによりOGPが重複した場合等にご利用ください。 ?></p>
						</td>
					</tr>
				</table>
			</div>
			<input type="hidden" name="submit_settings" id="submit_settings" value="<?php esc_html_e('Support function settings', 'friendly-functions-for-welcart'); //サポート機能の設定 ?>">
			<p class="submit">
				<input type="submit" name="submit_settings_data_1" id="submit_settings_data_1" class="button-primary" value="<?php esc_html_e('Save the settings', 'friendly-functions-for-welcart'); //設定を保存 ?>">
			</p>
		</form>
	</div>

	<div id="settings2" class="tab_content">
		<form class="settingsForm2" method="post" action="admin.php?page=ffw_function_settings">
			<div class="ffwGrayBackground">
				<table class="form-table">
					<tr valign="top">
						<th scope="row"><label for="shippingDiscountsMessage"><?php esc_html_e('Show the amount up to the shipping discount', 'friendly-functions-for-welcart'); //送料割引までの金額を表示 ?></label></th>
						<td>
							<select name="shippingDiscountsMessage">
								<option value="yes"<?php if($shippingDiscountsMessage == 'yes'){echo ' selected';} ?>><?php esc_html_e('Show', 'friendly-functions-for-welcart'); //表示する ?></option>
								<option value="no"<?php if($shippingDiscountsMessage == 'no' || empty($shippingDiscountsMessage)){echo ' selected';} ?>><?php esc_html_e('Hide', 'friendly-functions-for-welcart'); //表示しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('Show the amount up to the shipping discount on the cart page. This is available if you have set up a "Shipping Discount".', 'friendly-functions-for-welcart'); //カートページに送料割引までの金額を表示します。「送料割引」を設定している場合にご利用いただけます。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="postagePrivilegeMessage"><?php esc_html_e('Show the amount up to free shipping', 'friendly-functions-for-welcart'); //送料無料までの金額を表示 ?></label></th>
						<td>
							<select name="postagePrivilegeMessage">
								<option value="yes"<?php if($postagePrivilegeMessage == 'yes'){echo ' selected';} ?>><?php esc_html_e('Show', 'friendly-functions-for-welcart'); //表示する ?></option>
								<option value="no"<?php if($postagePrivilegeMessage == 'no' || empty($postagePrivilegeMessage)){echo ' selected';} ?>><?php esc_html_e('Hide', 'friendly-functions-for-welcart'); //表示しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('Show the amount up to free shipping on the cart page, which is available if you have set the "Conditions for free shipping" in Welcart.', 'friendly-functions-for-welcart'); //カートページに送料無料までの金額を表示します。Welcartの「送料無料条件」を設定している場合にご利用いただけます。 ?></p>
						</td>
					</tr>
					<?php if(get_locale() == 'ja'): ?>
					<tr valign="top">
						<th scope="row"><label for="displayFurigana"><?php esc_html_e('Show/hide "Furigana"', 'friendly-functions-for-welcart'); //「フリガナ」の表示・非表示 ?></label></th>
						<td>
							<select name="displayFurigana">
								<option value="yes"<?php if($displayFurigana == 'yes' || empty($displayFurigana)){echo ' selected';} ?>><?php esc_html_e('Show', 'friendly-functions-for-welcart'); //表示する ?></option>
								<option value="no"<?php if($displayFurigana == 'no'){echo ' selected';} ?>><?php esc_html_e('Hide', 'friendly-functions-for-welcart'); //表示しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('You can delete and hide the "Furigana" field from the input form.', 'friendly-functions-for-welcart'); //入力フォームから「フリガナ」の項目を削除し非表示にできます。 ?></p>
						</td>
					</tr>
					<?php endif; ?>
					<tr valign="top">
						<th scope="row"><label for="displayFaxNum"><?php esc_html_e('Show/hide "FAX Number"', 'friendly-functions-for-welcart'); //「FAX番号」の表示・非表示 ?></label></th>
						<td>
							<select name="displayFaxNum">
								<option value="yes"<?php if($displayFaxNum == 'yes' || empty($displayFaxNum)){echo ' selected';} ?>><?php esc_html_e('Show', 'friendly-functions-for-welcart'); //表示する ?></option>
								<option value="no"<?php if($displayFaxNum == 'no'){echo ' selected';} ?>><?php esc_html_e('Hide', 'friendly-functions-for-welcart'); //表示しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('You can delete and hide the "FAX Number" field from the input form.', 'friendly-functions-for-welcart'); //入力フォームから「FAX番号」の項目を削除し非表示にできます。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="quantityEntryNum"><?php esc_html_e('Change cart page quantity entry to "number"', 'friendly-functions-for-welcart'); //カートページ数量入力を「number」に変更 ?></label></th>
						<td>
							<select name="quantityEntryNum">
								<option value="yes"<?php if($quantityEntryNum == 'yes'){echo ' selected';} ?>><?php esc_html_e('Use', 'friendly-functions-for-welcart'); //利用する ?></option>
								<option value="no"<?php if($quantityEntryNum == 'no' || empty($quantityEntryNum)){echo ' selected';} ?>><?php esc_html_e('No use', 'friendly-functions-for-welcart'); //利用しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('The type of quantity entry on the cart page will be set to "number" so that the quantity can be changed by cursor operation.', 'friendly-functions-for-welcart'); //カートページの数量入力のタイプを「number」にし、カーソル操作で数量の変更ができるようになります。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="formErrorCheck"><?php esc_html_e('Check before transitioning to the input form', 'friendly-functions-for-welcart'); //入力フォームの遷移前チェック ?></label></th>
						<td>
							<select name="formErrorCheck">
								<option value="yes"<?php if($formErrorCheck == 'yes'){echo ' selected';} ?>><?php esc_html_e('Use', 'friendly-functions-for-welcart'); //利用する ?></option>
								<option value="no"<?php if($formErrorCheck == 'no' || empty($formErrorCheck)){echo ' selected';} ?>><?php esc_html_e('No use', 'friendly-functions-for-welcart'); //利用しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('In the input form of the cart and member page, the validation check is performed before the page transition to ensure that there are no omissions when clicking "Submit".', 'friendly-functions-for-welcart'); //カート・メンバーページの入力フォームで、「送信」クリック時に入力漏れがないかページ遷移前にバリデーションチェックします。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="preventExpiration"><?php esc_html_e('Prevent documents from expiring by using "Back"', 'friendly-functions-for-welcart'); //「戻る」によるドキュメント有効切れ防止 ?></label></th>
						<td>
							<select name="preventExpiration">
								<option value="yes"<?php if($preventExpiration == 'yes'){echo ' selected';} ?>><?php esc_html_e('Use', 'friendly-functions-for-welcart'); //利用する ?></option>
								<option value="no"<?php if($preventExpiration == 'no' || empty($preventExpiration)){echo ' selected';} ?>><?php esc_html_e('No use', 'friendly-functions-for-welcart'); //利用しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('This prevents the document from expiring due to "Back", thus preventing the form from being re-filled. This may not be applicable in some environments.', 'friendly-functions-for-welcart'); //「戻る」によるドキュメント有効切れを防ぐことで、フォームの再入力を防ぎます。環境によっては適用されない場合があります。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="onThanksgivingPage"><?php esc_html_e('Show order number and order date', 'friendly-functions-for-welcart'); //注文番号・注文日時を表示 ?></label></th>
						<td>
							<select name="onThanksgivingPage">
								<option value="yes"<?php if($onThanksgivingPage == 'yes'){echo ' selected';} ?>><?php esc_html_e('Show', 'friendly-functions-for-welcart'); //表示する ?></option>
								<option value="no"<?php if($onThanksgivingPage == 'no' || empty($onThanksgivingPage)){echo ' selected';} ?>><?php esc_html_e('Hide', 'friendly-functions-for-welcart'); //表示しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('The order number and order date will be displayed on the Thank You page (purchase completion screen).', 'friendly-functions-for-welcart'); //サンクスページ（購入完了画面）に注文番号・注文日時を表示します。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="extendSearch"><?php esc_html_e('Expanded search results', 'friendly-functions-for-welcart'); //検索結果の拡張 ?></label></th>
						<td>
							<select name="extendSearch">
								<option value="yes"<?php if($extendSearch == 'yes'){echo ' selected';} ?>><?php esc_html_e('Use', 'friendly-functions-for-welcart'); //利用する ?></option>
								<option value="no"<?php if($extendSearch == 'no' || empty($extendSearch)){echo ' selected';} ?>><?php esc_html_e('No use', 'friendly-functions-for-welcart'); //利用しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('It also includes custom field values in the search target.', 'friendly-functions-for-welcart'); //検索対象にカスタムフィールドの値も含めます。また、「ひらがな」と「カタカナ」・「全角英数」と「半角英数」を区別せず検索します。 ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="cssInlineOutput"><?php esc_html_e('Inline output of Welcart\'s CSS files', 'friendly-functions-for-welcart'); //WelcartのCSSファイルをインライン出力 ?></label></th>
						<td>
							<select name="cssInlineOutput">
								<option value="yes"<?php if($cssInlineOutput == 'yes'){echo ' selected';} ?>><?php esc_html_e('Use', 'friendly-functions-for-welcart'); //利用する ?></option>
								<option value="no"<?php if($cssInlineOutput == 'no' || empty($cssInlineOutput)){echo ' selected';} ?>><?php esc_html_e('No use', 'friendly-functions-for-welcart'); //利用しない ?></option>
							</select>
							<p class="description"><?php esc_html_e('Output "usces_default.css" and "usces_cart.css" inline in "head" to reduce the number of network communication.', 'friendly-functions-for-welcart'); //「usces_default.css」と「usces_cart.css」を「head」内にインラインで出力し、ネットワーク通信回数を削減します。 ?></p>
						</td>
					</tr>
				</table>
			</div>
			<input type="hidden" name="submit_settings" id="submit_settings" value="<?php esc_html_e('Usability settings', 'friendly-functions-for-welcart'); //ユーザビリティの設定 ?>">
			<p class="submit">
				<input type="submit" name="submit_settings_data_2" id="submit_settings_data_2" class="button-primary" value="<?php esc_html_e('Save the settings', 'friendly-functions-for-welcart'); //設定を保存 ?>">
			</p>
		</form>
	</div>


</section>

<script>
	/* 設定保存メッセージフェードアウト */
	jQuery(function($){
		setTimeout(function(){
			$(".saveMessage").fadeOut("600");
		},3000);
	});
</script>
<?php else: //Welcartが無効の場合 ?>
<section class="ffwSettingsSection">
	<div class="error"><p><?php echo sprintf(__('To use "Friendly Functions for Welcart", you need to add "<a href="%s" target="_blank" rel="noopener">Welcart e-Commerce</a>" should be enabled.', 'friendly-functions-for-welcart'), home_url('/wp-admin/plugin-install.php?tab=plugin-information&plugin=usc-e-shop')); //「Friendly Functions for Welcart」を利用するには「Welcart e-Commerce」を有効化してください。 ?></p></div>
</section>
<?php endif; ?>