<?php
/* Template Name: 機能 */

if (!defined('ABSPATH')) exit;

/* Welcart有効確認 */
include_once(ABSPATH . 'wp-admin/includes/plugin.php');
if (is_plugin_active('usc-e-shop/usc-e-shop.php')) {

	/* 設定情報 */
	$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
	if(!empty($friendlyFunctionsForWelcartData)){
		foreach ($friendlyFunctionsForWelcartData as $key => $val) {
			$$key = esc_html($val);
		}
	}

	/* Welcartが吐き出すOGPプロパティーを削除 */
	if($removeOGP == 'yes'){
		remove_action('wp_head', 'usces_action_ogp_meta');
	}

	/* 受注メールの差出人を購入者のアドレスに変更 */
	if($changeOrderEmail == 'yes'){
		function friendly_functions_for_welcart_order_return_path_change($order_para, $entry, $data)
		{
			$order_para['from_address'] = $entry['customer']['mailaddress1'];
			return $order_para;
		}
		add_filter('usces_send_ordermail_para_to_manager', 'friendly_functions_for_welcart_order_return_path_change', 10, 3);
	}

	/* 購入額による送料割引 */
	if(!empty($shippingDiscountsA) && !empty($shippingDiscountsB)){
		function friendly_functions_for_welcart_filter_set_cart_fees_shipping_charge($shipping_charge, $carts, $entries)
		{
			$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
			if ($entries['order']['total_items_price'] >= mb_convert_kana($friendlyFunctionsForWelcartData['shippingDiscountsA'], 'n')) {
				$shipping_charge -= mb_convert_kana($friendlyFunctionsForWelcartData['shippingDiscountsB'], 'n');
			}
			return $shipping_charge;
		}
		add_filter('usces_filter_set_cart_fees_shipping_charge', 'friendly_functions_for_welcart_filter_set_cart_fees_shipping_charge', 10, 3);
	}

	/* 「FAX番号」の非表示 */
	if($displayFaxNum == 'no' || $removeOrderEmailMemberNo == 'yes'){
		//購入者宛
		function friendly_functions_for_welcart_send_ordermail_para_to_customer( $confirm_para, $entry, $data ) {
			$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
			$removeOrderEmailMemberNo = esc_html($friendlyFunctionsForWelcartData['removeOrderEmailMemberNo']);
			$displayFaxNum = esc_html($friendlyFunctionsForWelcartData['displayFaxNum']);
			if($removeOrderEmailMemberNo == 'yes'){
				$confirm_para['message'] = preg_replace('/^会員No : .*\n/um','',$confirm_para['message']);
				$confirm_para['message'] = preg_replace('/^Membership Number : .*\n/um','',$confirm_para['message']);
			}
			if($displayFaxNum == 'no'){
				$confirm_para['message'] = preg_replace('/^FAX番号 : .*\n/um','',$confirm_para['message']);
				$confirm_para['message'] = preg_replace('/^Fax Number : .*\n/um','',$confirm_para['message']);
			}
			return $confirm_para;
		}
		add_filter( 'usces_send_ordermail_para_to_customer',  'friendly_functions_for_welcart_send_ordermail_para_to_customer', 10, 3 );
		//管理者宛
		function friendly_functions_for_welcart_send_ordermail_para_to_manager( $bcc_para, $entry, $data ) {
			$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
			$removeOrderEmailMemberNo = esc_html($friendlyFunctionsForWelcartData['removeOrderEmailMemberNo']);
			$displayFaxNum = esc_html($friendlyFunctionsForWelcartData['displayFaxNum']);
			if($removeOrderEmailMemberNo == 'yes'){
				$bcc_para['message'] = preg_replace('/^会員No : .*\n/um','',$bcc_para['message']);
				$bcc_para['message'] = preg_replace('/^Membership Number : .*\n/um','',$bcc_para['message']);
			}
			if($displayFaxNum == 'no'){
				$bcc_para['message'] = preg_replace('/^FAX番号 : .*\n/um','',$bcc_para['message']);
				$bcc_para['message'] = preg_replace('/^Fax Number : .*\n/um','',$bcc_para['message']);
			}
			return $bcc_para;
		}
		add_filter( 'usces_send_ordermail_para_to_manager',  'friendly_functions_for_welcart_send_ordermail_para_to_manager', 10, 3 );
		//FAX番号項目非表示CSS
		if($displayFaxNum == 'no'){
			$friendlyFunctionsForWelcartHideFaxNumCss = '#fax_row,#memberinfo #fax_row,.fax-row{display:none;}';
		}else{
			$friendlyFunctionsForWelcartHideFaxNumCss = '';
		}
	}
	update_option('friendlyFunctionsForWelcartHideFaxNumCss',$friendlyFunctionsForWelcartHideFaxNumCss);

	/* 「フリガナ」の非表示 */
	if($displayFurigana == 'no'){
		function friendly_functions_for_welcart_furigana_customer($furigana_customer, $type, $values ){
			$furigana_customer = '';
			return $furigana_customer;
		}
		add_filter('usces_filter_furigana_form', 'friendly_functions_for_welcart_furigana_customer', 10, 3);
		function friendly_functions_for_welcart_furigana_confirm_customer($furigana_customer, $type, $values){
			$furigana_customer = '';
			return $furigana_customer;
		}
		add_filter('usces_filter_furigana_confirm_customer', 'friendly_functions_for_welcart_furigana_confirm_customer', 10, 3);
		function friendly_functions_for_welcart_furigana_confirm_delivery($furigana_delivery, $type, $values){
			$furigana_delivery = '';
			return $furigana_delivery;
		}
		add_filter('usces_filter_furigana_confirm_delivery', 'friendly_functions_for_welcart_furigana_confirm_delivery', 10, 3);
	}

	/* カートページに送料割引までの金額を表示 */
	if($shippingDiscountsMessage == 'yes'){
		//表示テキスト関数
		function friendly_functions_for_welcart_shipping_discounts_message(){
			global $usces;
			$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
			$shippingDiscountsA = mb_convert_kana($friendlyFunctionsForWelcartData['shippingDiscountsA'], 'n');
			$shippingDiscountsB = mb_convert_kana($friendlyFunctionsForWelcartData['shippingDiscountsB'], 'n');
			$totalPrice = esc_html($usces->get_total_price());
			if(!empty($shippingDiscountsA) && !empty($shippingDiscountsB)){
				$num = ($shippingDiscountsA - $totalPrice);
				$postagePrivilegeStyle = 'display: table; margin: 8px 0 8px auto; border: #999 1px solid; padding: 4px 12px; border-radius: 3px; -webkit-border-radius: 3px; -moz-border-radius: 3px;';
				if(0 < $num){
					return '<div id="postagePrivilege" style="'.$postagePrivilegeStyle.'">'.sprintf(__('Spend $%1$s more and get $%2$s off shipping', 'friendly-functions-for-welcart'), number_format($num), $shippingDiscountsB).'</div>'; //あと～円のお買い上げで送料～円OFF
				}elseif($shippingDiscountsA < $totalPrice){
					return '<div id="postagePrivilege" style="'.$postagePrivilegeStyle.'">'.sprintf(__('Purchase over $%1$s so $%2$s off shipping', 'friendly-functions-for-welcart'), number_format($shippingDiscountsA), $shippingDiscountsB).'</div>'; //～円以上のお買い上げのため送料～円OFF
				}
			}
		}
		function friendly_functions_for_welcart_shipping_discounts_message_filter($header){
			return $header.friendly_functions_for_welcart_shipping_discounts_message();
		}
		add_action('usces_filter_cart_page_header', 'friendly_functions_for_welcart_shipping_discounts_message_filter');
		function friendly_functions_for_welcart_shipping_discounts_message_action(){
			echo friendly_functions_for_welcart_shipping_discounts_message();
		}
		add_action('usces_action_cart_page_header', 'friendly_functions_for_welcart_shipping_discounts_message_action');
	}

	/* カートページに送料無料までの金額を表示 */
	if($postagePrivilegeMessage == 'yes'){
		//表示テキスト関数
		function friendly_functions_for_welcart_postage_privilege_message(){
			global $usces;
			$usces_options = $usces->options;
			$postagePrivilege = esc_html($usces_options['postage_privilege']);
			$totalPrice = esc_html($usces->get_total_price());
			if(!empty($postagePrivilege)){
				$num = ($postagePrivilege - $totalPrice);
				$postagePrivilegeStyle = 'display: table; margin: 8px 0 8px auto; border: #999 1px solid; padding: 4px 12px; border-radius: 3px; -webkit-border-radius: 3px; -moz-border-radius: 3px;';
				if(0 < $num){
					return '<div id="postagePrivilege" style="'.$postagePrivilegeStyle.'">'.sprintf(__('Free shipping with purchase of $%s more', 'friendly-functions-for-welcart'), number_format($num)).'</div>'; //あと～円のお買い上げで送料無料
				}elseif($postagePrivilege < $totalPrice){
					return '<div id="postagePrivilege" style="'.$postagePrivilegeStyle.'">'.sprintf(__('Free shipping since the purchase is over $%s', 'friendly-functions-for-welcart'), number_format($postagePrivilege)).'</div>'; //～円以上のお買い上げのため送料無料
				}
			}
		}
		function friendly_functions_for_welcart_postage_privilege_message_filter($header){
			return $header.friendly_functions_for_welcart_postage_privilege_message();
		}
		add_action('usces_filter_cart_page_header', 'friendly_functions_for_welcart_postage_privilege_message_filter');
		function friendly_functions_for_welcart_postage_privilege_message_action(){
			echo friendly_functions_for_welcart_postage_privilege_message();
		}
		add_action('usces_action_cart_page_header', 'friendly_functions_for_welcart_postage_privilege_message_action');
	}

	/* カートページ数量入力をnumberにする */
	if($quantityEntryNum == 'yes'){
		function friendly_functions_for_welcart_change_quant_input($quant)
		{
			return str_replace('text', 'number', $quant);
		}
		add_filter('usces_filter_cart_rows_quant', 'friendly_functions_for_welcart_change_quant_input');
	}

	/* 買い物を続けるのリンク先変更 */
	if(!empty($changeLinkCartPrebutton)){
		function friendly_functions_for_welcart_cart_prebutton_redirect(){
			$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
			$url = esc_url($friendlyFunctionsForWelcartData['changeLinkCartPrebutton']);
			return ' onclick="location.href=\''.$url.'/\'"';
		}
		add_filter('usces_filter_cart_prebutton', 'friendly_functions_for_welcart_cart_prebutton_redirect');
	}

	/* ログイン後の遷移ページ変更 */
	if(!empty($changeAfterLogin)){
		function friendly_functions_for_welcart_login_redirect()
		{
			$referer = $_SERVER['HTTP_REFERER'];
			$url_array = parse_url($referer);
			if (preg_match("/usces-cart/", $url_array['path'])){
			}else{
				$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
				$url = esc_url($friendlyFunctionsForWelcartData['changeAfterLogin']);
				wp_redirect($url);
				exit;
			}
		}
		add_action('usces_action_after_login', 'friendly_functions_for_welcart_login_redirect');
	}

	/* ログアウト後の遷移ページ変更 */
	if(!empty($changeAfterLogout)){
		function friendly_functions_for_welcart_logout_redirect()
		{
			$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
			$url = esc_url($friendlyFunctionsForWelcartData['changeAfterLogout']);
			wp_redirect($url);
			exit;
		}
		add_action('usces_action_member_logout', 'friendly_functions_for_welcart_logout_redirect');
	}

	if(!empty($conversionTag) || $onThanksgivingPage == 'yes'){
		function friendly_functions_for_welcart_on_thankspage($tag, $usces_entries, $usces_carts)
		{
			$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
			$onThanksgivingPage = $friendlyFunctionsForWelcartData['onThanksgivingPage'];
			$conversionTag = $friendlyFunctionsForWelcartData['conversionTag'];

			/* サンクスページに注文番号・注文日時・送信先を表示 */
			if($onThanksgivingPage == 'yes'){
				$orderID = esc_html(usces_get_deco_order_id($usces_entries['order']['ID'])); //注文番号
				$orderDate = date_i18n( 'Y/m/d H:i' ); //注文日時
				$html .= '
<div id="orderDataBox" style="font-size: 16px; font-weight: bold; margin-top: 40px; margin-right: auto; margin-left: auto; display: table;">
<div id="orderDate">
<span>'.esc_html__('Order Date', 'friendly-functions-for-welcart').'</span>
<span style="margin-right: 8px; margin-left: 8px;">'.esc_html__(':', 'friendly-functions-for-welcart').'</span>
<span>'.$orderDate.'</span>
</div>
<div id="orderID">
<span>'.esc_html__('Order Number', 'friendly-functions-for-welcart').'</span>
<span style="margin-right: 8px; margin-left: 8px;">'.esc_html__(':', 'friendly-functions-for-welcart').'</span>
<span>'.$orderID.'</span>
</div>
</div>
'; //受注日時 & 注文番号
			}

			/* サンクスページにコンバージョンタグ設置 */
			if(!empty($conversionTag)){
				$html .= stripslashes(htmlspecialchars_decode($conversionTag, ENT_QUOTES));
			}
			return $html;
		}
		add_filter('usces_filter_conversion_tracking', 'friendly_functions_for_welcart_on_thankspage', 99, 3);
	}

	/* クーポン機能 */
	if(!empty($couponDiscountsCode) && !empty($couponDiscountsPrice)){
		//クーポンコード入力欄表示
		//入力欄関数
		function friendly_functions_for_welcart_coupon_code_input(){
			return '
<table class="customer_form">
<tbody>
<tr class="customkey_coupon">
<th scope="row">'.esc_html__('Coupon Code', 'friendly-functions-for-welcart').'</th>
<td colspan="2">
<input type="text" name="custom_order[coupon]" class="iopt_text" value="">
<span class="couponText">'.esc_html__('If you have a coupon code, please enter it here.', 'friendly-functions-for-welcart').'</span>
</td>
</tr>
</tbody>
</table>'; //クーポンコード & クーポンコードがある方はこちらにご入力ください。
		}
		function friendly_functions_for_welcart_filter_custom_field_input_filter($html){
			$html .= friendly_functions_for_welcart_coupon_code_input();
			return $html;
		}
		add_filter('usces_filter_delivery_flag', 'friendly_functions_for_welcart_filter_custom_field_input_filter', 10, 1 );
		function friendly_functions_for_welcart_filter_custom_field_input_action(){
			echo friendly_functions_for_welcart_coupon_code_input();
		}
		add_action('usces_action_delivery_flag', 'friendly_functions_for_welcart_filter_custom_field_input_action', 10, 1 );
		//割引設定
		if($couponDiscountsUnit == 'price'){ //額で割引
			function friendly_functions_for_welcart_coupon_order_discount($discount, $cart){
				global $usces;
				$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
				$entry = $usces->cart->get_entry();
				if($entry['custom_order']['coupon'] == $friendlyFunctionsForWelcartData['couponDiscountsCode']){
					$discount = -$friendlyFunctionsForWelcartData['couponDiscountsPrice'];
				}
				return $discount;
			}
			add_filter('usces_order_discount', 'friendly_functions_for_welcart_coupon_order_discount', 10, 2);
		}elseif($couponDiscountsUnit == 'percent'){ //%で割引
			function friendly_functions_for_welcart_coupon_order_discount_percent($discount, $cart){
				global $usces;
				$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
				$entry = $usces->cart->get_entry();
				$total_items_price = $usces->get_total_price();
				if($entry['custom_order']['coupon'] == $friendlyFunctionsForWelcartData['couponDiscountsCode']){
					$discount = ceil($total_items_price * $friendlyFunctionsForWelcartData['couponDiscountsPrice'] * 0.01 * -1);
				}
				return $discount;
			}
			add_filter('usces_order_discount', 'friendly_functions_for_welcart_coupon_order_discount_percent', 10, 2);
		}
		//「キャンペーン割引」を「クーポン割引」に書き換え
		function friendly_functions_for_welcart_coupon_confirm_discount_label(){
			global $usces;
			$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
			$entry = $usces->cart->get_entry();
			if($entry['custom_order']['coupon'] == $friendlyFunctionsForWelcartData['couponDiscountsCode'] || $usces->get_order_meta_value('csod_coupon', $_REQUEST['order_id']) == true){
				$text = esc_html__('Coupon Discount', 'friendly-functions-for-welcart'); //クーポン割引
			} else {
				$text = __('Campaign disnount', 'usces'); //キャンペーン割引
			}
			return $text;
		}
		add_filter('usces_confirm_discount_label', 'friendly_functions_for_welcart_coupon_confirm_discount_label', 10, 1);
		add_filter('usces_filter_disnount_label', 'friendly_functions_for_welcart_coupon_confirm_discount_label', 10, 1);
		//クーポンコードがエラーの時の表示
		////入力欄関数
		function friendly_functions_for_welcart_coupon_code_error_message(){
			global $usces;
			$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
			$entry = $usces->cart->get_entry();
			if($entry['custom_order']['coupon'] == true && $entry['custom_order']['coupon'] != $friendlyFunctionsForWelcartData['couponDiscountsCode']){
				return '<p class="coupon-error" style="color: #f00; display: table; margin-right: auto; margin-left: auto; text-align: left; line-height: 125%;">'.esc_html__('* The coupon code you entered is invalid. If you wish to reenter the code, please return to the previous screen.', 'friendly-functions-for-welcart').'</p>'; //※入力されたクーポンコードは無効です。再入力される場合は前画面に戻って行ってください。
			}
		}
		function friendly_functions_for_welcart_coupon_confirm_page_header_filter($header){
			return $header.friendly_functions_for_welcart_coupon_code_error_message();
		}
		add_filter('usces_filter_confirm_page_header', 'friendly_functions_for_welcart_coupon_confirm_page_header_filter', 10, 1);
		function friendly_functions_for_welcart_coupon_confirm_page_header_action(){
			echo friendly_functions_for_welcart_coupon_code_error_message();
		}
		add_action('usces_action_confirm_page_header', 'friendly_functions_for_welcart_coupon_confirm_page_header_action', 10, 1);
	}

	/* 発行書類に画像を表示 */
	if(!empty($pdfSignImage)){
		function friendly_functions_for_welcart_filter_pdf_sign(){
			$friendlyFunctionsForWelcartData = get_option('friendlyFunctionsForWelcartData');
			return $friendlyFunctionsForWelcartData['pdfSignImage'];
		}
		add_filter('usces_filter_pdf_estimate_sign', 'friendly_functions_for_welcart_filter_pdf_sign'); //見積書
		add_filter('usces_filter_pdf_invoice_sign', 'friendly_functions_for_welcart_filter_pdf_sign'); //納品書
		add_filter('usces_filter_pdf_receipt_sign', 'friendly_functions_for_welcart_filter_pdf_sign'); //領収書
		add_filter('usces_filter_pdf_bill_sign', 'friendly_functions_for_welcart_filter_pdf_sign'); //請求書
	}

	/* 入力フォームのリアルタイムチェック */
	if($formErrorCheck == 'yes'){
		//「head」内にスクリプト出力
		function friendly_functions_for_welcart_validation_engine_script(){
			if(is_page(array('usces-cart','usces-member'))){
?>
<script type="text/javascript">
	jQuery(function(){
		jQuery("#name1, #name2, #zipcode, #customer_pref, #address1, #address2, #tel, #password1, #password2").addClass("validate[required]");
		jQuery("#customer_pref option:first-child").val("");
		jQuery("input[name*='mailaddress1'],input[name*='mailaddress2']").addClass("validate[required,custom[email]]");
		jQuery("form td").css('position', 'relative');
		jQuery(document).ready(function($){
			jQuery("form").validationEngine({
				promptPosition: "topLeft:0"
			});
		});
		jQuery(".back_cart_button, .back_to_customer_button").click(function(){
			jQuery("form").validationEngine('hideAll');
			jQuery("form").validationEngine('detach');
			return true;
		});
	});
</script>
<?php
			}
		}
		add_action('wp_head', 'friendly_functions_for_welcart_validation_engine_script');

		//ファイルの読み込み
		function friendly_functions_for_welcart_enqueue_style_script()
		{
			if(is_page(array('usces-cart','usces-member'))){
				wp_enqueue_style( 'validationEngine.jquery.css', FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_URL . 'validation-engine-master/css/validationEngine.jquery.css', array(), date("ymdHis", filemtime(FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_DIR . 'validation-engine-master/css/validationEngine.jquery.css')), 'all');
				wp_enqueue_script( 'jquery.validationEngine.js', FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_URL . 'validation-engine-master/js/jquery.validationEngine.js', array(), date("ymdHis", filemtime(FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_DIR . 'validation-engine-master/js/jquery.validationEngine.js')), 'all');
				if(get_locale() == 'ja'){
					wp_enqueue_script( 'jquery.validationEngine-ja.js', FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_URL . 'validation-engine-master/js/languages/jquery.validationEngine-ja.js', array(), date("ymdHis", filemtime(FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_DIR . 'validation-engine-master/js/languages/jquery.validationEngine-ja.js')), 'all');
				}else{
					wp_enqueue_script( 'jquery.validationEngine-en.js', FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_URL . 'validation-engine-master/js/languages/jquery.validationEngine-en.js', array(), date("ymdHis", filemtime(FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_DIR . 'validation-engine-master/js/languages/jquery.validationEngine-en.js')), 'all');
				}
			}
		}
		add_action('wp_enqueue_scripts', 'friendly_functions_for_welcart_enqueue_style_script');
	}

	/* CSSインライン出力 */
	if($cssInlineOutput == 'yes'){
		function friendly_functions_for_welcart_style_queues()
		{
			global $wp_styles;
			global $wp_styles_array;
			$site_url = site_url('/');

			foreach ($wp_styles->queue as $handle) {
				$wp_styles_src = $wp_styles->registered[$handle]->src;
				if ($handle == 'theme_cart_css' || $handle == 'usces_cart_css' || $handle == 'usces_default_css') {
					//外部CSS読み込み キャンセル
					wp_dequeue_style($handle);
					//外部CSSリスト作成
					$wp_styles_uri = '';
					if (false !== strpos($wp_styles_src, '/wp-includes/')) {
						$wp_styles_uri = str_replace('/wp-includes/', ABSPATH . 'wp-includes/', $wp_styles_src);
					}
					if (false !== strpos($wp_styles_src, $site_url)) {
						$wp_styles_uri = str_replace($site_url, ABSPATH, $wp_styles_src);
					}
					if ($wp_styles_uri) {
						$wp_styles_array[] = array('uri' => $wp_styles_uri, 'queue' => $handle);
					}
				}
			}
		}
		add_action('wp_print_styles', 'friendly_functions_for_welcart_style_queues', 999);
	}

	if($cssInlineOutput == 'yes' || $displayFaxNum == 'no'){
		function friendly_functions_for_welcart_wp_get_custom_css($css)
		{
			//外部CSSリスト
			global $wp_styles_array;

			$css_data = '';
			$site_url = site_url('/');

			//外部CSSリスト読み込み
			require_once(ABSPATH . 'wp-admin/includes/file.php');
			if (is_array($wp_styles_array)) {
				if (WP_Filesystem()) {
					global $wp_filesystem;
					foreach ($wp_styles_array as $wp_style) {
						$css_name = $wp_style['queue'];
						$css_tmp = $wp_filesystem->get_contents($wp_style['uri']);
						$css_tmp = friendly_functions_for_welcart_css_simple_minify($css_tmp, $css_name);
						$css_data .= '/*' . $css_name . '*/' . $css_tmp . "\n";
					}
				}
			}
			//インラインCSS追加
			$friendlyFunctionsForWelcartHideFaxNumCss = get_option('friendlyFunctionsForWelcartHideFaxNumCss');
			if(!empty($friendlyFunctionsForWelcartHideFaxNumCss)){
				$css_data .= '/*ffw-inline-css*/' . esc_html($friendlyFunctionsForWelcartHideFaxNumCss) . "\n";
			}
			//カスタムCSS追加
			$wp_custom_css = friendly_functions_for_welcart_css_simple_minify($css, 'wp_custom_css');
			if ($wp_custom_css) {
				$css_data .= '/*wp-custom-css*/' . $wp_custom_css . "\n";
			}
			return $css_data;
		}
		add_filter('wp_get_custom_css', 'friendly_functions_for_welcart_wp_get_custom_css');
	}

	/* CSS圧縮 */
	function friendly_functions_for_welcart_css_simple_minify($css, $css_name)
	{
		$site_url = site_url('/');
		if ($css != '') {
			//Character Code削除
			$css = str_replace('@charset "utf-8";', '', $css);
			$css = str_replace('@charset"utf-8";', '', $css);
			//コメント削除
			$css = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $css);
			//改行削除
			$css = str_replace(array("\r\n", "\r", "\n", "\t"), '', $css);
			//スペース削除
			$css = str_replace(array('  ', '    ', '    '), '', $css);
			$css = str_replace(': ', ':', $css);
			$css = str_replace(' :', ':', $css);
			$css = str_replace(' }', '}', $css);
			$css = str_replace('} ', '}', $css);
		}
		return $css;
	}

	/* 「戻る」でドキュメント有効切れを防ぐ */
	if($preventExpiration == 'yes'){
		function friendly_functions_for_welcart_add_header_session()
		{
			header("Cache-Control: private");
			header("Pragma: no-cahce");
			header("Expires: ");
			header("Last-Modified: ");
		}
		add_action('send_headers', 'friendly_functions_for_welcart_add_header_session');
	}

	/* 検索結果の拡張 */
	if($extendSearch == 'yes'){
		function friendly_functions_for_welcart_custom_search($search, $wp_query)
		{
			global $wpdb;

			if (!$wp_query->is_search)
				return $search;
			if (!isset($wp_query->query_vars))
				return $search;

			$search_words = explode(' ', isset($wp_query->query_vars['s']) ? $wp_query->query_vars['s'] : '');
			if (count($search_words) > 0) {
				$search = '';
				$search .= "AND post_type = 'post'";
				foreach ($search_words as $word) {
					if (!empty($word)) {
						$search_word = '%' . esc_sql($word) . '%';
						$search .= " AND (
										{$wpdb->posts}.post_title LIKE '{$search_word}'
									OR {$wpdb->posts}.post_content LIKE '{$search_word}'
									OR {$wpdb->posts}.ID IN (
									SELECT distinct post_id
									FROM {$wpdb->postmeta}
									WHERE meta_value LIKE '{$search_word}'
									)
								) ";
					}
				}
			}
			return $search;
		}
		add_filter('posts_search', 'friendly_functions_for_welcart_custom_search', 10, 2);

		function friendly_functions_for_welcart_the_slug()
		{
			global $post;
			if (is_home() || is_front_page()) {
				return ['home'];
			} elseif (is_page()) {
				$page_slug = get_page_uri($post->ID);
				return [$page_slug];
			} elseif (is_category()) {
				$categories = get_the_category($post->ID);
				$slugs = [];
				foreach ($categories as $category) {
					$slugs[] = $category->slug;
				}
				return $slugs;
			} else {
				return [];
			}
		}
		add_shortcode('the_slug', 'friendly_functions_for_welcart_the_slug');

		//「ひらがな」と「カタカナ」・「全角英数」と「半角英数」を区別せず検索
		function friendly_functions_for_welcart_change_search_char($where, $obj)
		{
			if ($obj->is_search) {
				$where = str_replace(".post_title", ".post_title COLLATE utf8_unicode_ci", $where);
				$where = str_replace(".post_content", ".post_content COLLATE utf8_unicode_ci", $where);
			}
			return $where;
		}
		add_filter('posts_where', 'friendly_functions_for_welcart_change_search_char', 10, 2);
	}
} //Welcart有効確認END