<?php
/* Template Name: その他 */

if(!defined('ABSPATH')) exit;

/* 画像アップロード用のタグ出力 */
function friendly_functions_for_welcart_generate_upload_image_tag($name, $value){
?>
<input name="<?php echo $name; ?>" type="text" value="<?php echo $value; ?>" class="regular-text" />
<div class="uplodedButtonWrap">
	<input type="button" name="<?php echo $name; ?>_slect" class="cursorPointer" value="<?php esc_html_e('select', 'friendly-functions-for-welcart'); //選択 ?>" />
	<input type="button" name="<?php echo $name; ?>_clear" class="cursorPointer" value="<?php esc_html_e('clear', 'friendly-functions-for-welcart'); //クリア ?>" />
	<div id="<?php echo $name; ?>Thumbnail" class="uplodedThumbnail">
		<?php if ($value): ?>
		<img src="<?php echo $value; ?>" alt="<?php esc_html_e('Image being selected', 'textDomain'); //選択中の画像 ?>" class="ffwUploadImg">
		<?php endif; ?>
	</div>
</div>

<script type="text/javascript">
	(function ($) {
		var custom_uploader;
		var titleText = '<?php esc_html_e('Please select an image', 'friendly-functions-for-welcart'); //画像を選択してください ?>';
		var buttonText = '<?php esc_html_e('Select image', 'friendly-functions-for-welcart'); //画像の選択 ?>';
		$("input:button[name=<?php echo $name; ?>_slect]").click(function(e) {
			e.preventDefault();
			if (custom_uploader) {
				custom_uploader.open();
				return;
			}
			custom_uploader = wp.media({
				title: titleText,
				library: {
					type: "image"
				},
				button: {
					text: buttonText
				},
				multiple: false
			});
			custom_uploader.on("select", function() {
				var images = custom_uploader.state().get("selection");
				images.each(function(file){
					$("input:text[name=<?php echo $name; ?>]").val("");
					$("#<?php echo $name; ?>Thumbnail").empty();
					$("input:text[name=<?php echo $name; ?>]").val(file.attributes.sizes.full.url);
					$("#<?php echo $name; ?>Thumbnail").append('<img src="'+file.attributes.sizes.full.url+'" class="ffwUploadImg" />');
				});
			});
			custom_uploader.open();
		});
		//クリアボタンを押した時の処理
		$("input:button[name=<?php echo $name; ?>_clear]").click(function() {
			$("input:text[name=<?php echo $name; ?>]").val("");
			$("#<?php echo $name; ?>Thumbnail").empty();
		});
	})(jQuery);
</script>
<?php
																				  }

/* 管理画面ファイル読み込み */
function friendly_functions_for_welcart_enqueue_admin_style_script()
{
	wp_enqueue_media(); //メディアアップローダのJavaScript API読み込み
	wp_enqueue_style('ffw_admin-style', FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_URL . '/style_admin.css', array(), date("ymdHis", filemtime(FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_DIR . '/style_admin.css')), 'all');
}
add_action('admin_enqueue_scripts', 'friendly_functions_for_welcart_enqueue_admin_style_script');

/* ダッシュボードにメニューの追加 */
function friendly_functions_for_welcart_create_custom_menu_page()
{
	require FRIENDLY_FUNCTIONS_FOR_WELCART__PLUGIN_DIR . 'ffw_function_settings.php';
}
function friendly_functions_for_welcart_register_custom_menu_page()
{
	add_menu_page( esc_html__('Friendly Functions for Welcart', 'friendly-functions-for-welcart'), esc_html__('Friendly Functions for Welcart', 'friendly-functions-for-welcart'), 0, 'ffw_function_settings', 'friendly_functions_for_welcart_create_custom_menu_page', 'dashicons-admin-generic', 3);
}
add_action('admin_menu', 'friendly_functions_for_welcart_register_custom_menu_page');

/* AjaxリクエストURL */
function friendly_functions_for_welcart_add_my_ajaxurl()
{
?><script>
	var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>';
</script><?php
}
?>